CodeForces - 356A(fhq-treap)

上个题目链接:CodeForces - 356A

Hooray! Berl II, the king of Berland is making a knight tournament. The king has already sent the message to all knights in the kingdom and they in turn agreed to participate in this grand event.

As for you, you’re just a simple peasant. There’s no surprise that you slept in this morning and were late for the tournament (it was a weekend, after all). Now you are really curious about the results of the tournament. This time the tournament in Berland went as follows:

There are n knights participating in the tournament. Each knight was assigned his unique number — an integer from 1 to n.
The tournament consisted of m fights, in the i-th fight the knights that were still in the game with numbers at least li and at most ri have fought for the right to continue taking part in the tournament.
After the i-th fight among all participants of the fight only one knight won — the knight number xi, he continued participating in the tournament. Other knights left the tournament.
The winner of the last (the m-th) fight (the knight number xm) became the winner of the tournament.
You fished out all the information about the fights from your friends. Now for each knight you want to know the name of the knight he was conquered by. We think that the knight number b was conquered by the knight number a, if there was a fight with both of these knights present and the winner was the knight number a.

Write the code that calculates for each knight, the name of the knight that beat him.

Input
The first line contains two integers n, m (2 ≤ n ≤ 3·105; 1 ≤ m ≤ 3·105) — the number of knights and the number of fights. Each of the following m lines contains three integers li, ri, xi (1 ≤ li < ri ≤ n; li ≤ xi ≤ ri) — the description of the i-th fight.

It is guaranteed that the input is correct and matches the problem statement. It is guaranteed that at least two knights took part in each battle.

Output
Print n integers. If the i-th knight lost, then the i-th number should equal the number of the knight that beat the knight number i. If the i-th knight is the winner, then the i-th number must equal 0.

Examples
inputCopy

4 3
1 2 1
1 3 3
1 4 4

outputCopy

3 1 4 0 

inputCopy

8 4
3 5 4
3 7 6
2 8 8
1 8 1

outputCopy

0 8 4 6 4 8 6 1 

Note
Consider the first test case. Knights 1 and 2 fought the first fight and knight 1 won. Knights 1 and 3 fought the second fight and knight 3 won. The last fight was between knights 3 and 4, knight 4 won.

题目大意:我们总共有n个骑士,他们将要进行m场比赛来决出谁是最强者,如果输了,就会退场,在最后决出胜负时,输出每个骑士是被谁淘汰的,最终的优胜者请输出0。

解题思路:这个题的题解我12号也写过一次,当时是说用STL的强大的功能来做,但是当时打比赛的时候我确实对set不是特别熟悉,其实我首先想到的是用无旋Treap树来做,但是因为B题Debug用了太长的时间了,(其实我想复杂了,因为少想了一个条件,但是其实少想的那个条件才是正解,),说多了,回归正题,其实set和无旋treap都是都是平衡树,所以两个都差不多,(好吧,我承认我是想练题了)。
代码:

#pragma GCC optimize(2)
#include <iostream>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <queue>
#include <time.h>
#include <random>
using namespace std;
#define int long long
#define ls root<<1
#define rs root<<1|1
const int maxn = 5e5 + 7;
const int inf = 0x3f3f3f3f;
std::mt19937 rnd(time(NULL));
struct treap
{
    int l, r, size, val, key;
} t[maxn << 2];
int tot, root;
inline int newnode(int val)
{
    t[++tot] = treap{0, 0, 1, val, rnd()};
    return tot;
}
inline void update(int now)
{
    t[now].size = t[t[now].l].size + t[t[now].r].size + 1;
}
inline void split(int &x,int &y,int now,int val)
{
    if(!now){
        x = y = 0;
        return;
    }
    if(t[now].val<=val){
        x = now;
        split(t[x].r, y, t[now].r, val);
    }
    else{
        y = now;
        split(x, t[y].l, t[now].l, val);
    }
    update(now);
}
inline int merge(int x,int y)
{
    if(!x||!y)
        return x + y;
    if(t[x].key>=t[y].key){
        t[x].r = merge(t[x].r, y);
        update(x);
        return x;
    }
    else{
        t[y].l = merge(x, t[y].l);
        update(y);
        return y;
    }
}
int x, y, z;
int ans[maxn];
inline void insert(int val)
{
    split(x, y, root, val);
    root = merge(merge(x, newnode(val)), y);
}
void dfs(int now,int f)
{
    int num = t[now].val;
    ans[num] = f;
    if(t[now].l)
        dfs(t[now].l, f);
    if(t[now].r)
        dfs(t[now].r, f);
}
inline void del(int l,int r,int f)
{
    split(x, y, root, l - 1);
    split(y, z, y, r);
    root = merge(x, z);
    dfs(y, f);
    insert(f);
    ans[f] = 0;
}
signed main()
{
#ifndef ONLINE_JUDGE
    //freopen("in.in", "r", stdin);
    //freopen("out.out", "w", stdout);
#endif
    int n, m;
    scanf("%lld%lld", &n, &m);
    for (int i = 1; i <= n;i++){
        insert(i);
    }
    while(m--){
        int l, r, x;
        scanf("%lld%lld%lld", &l, &r, &x);
        del(l, r, x);
    }
    for (int i = 1; i <= n;i++){
        if(i!=1)
            printf(" ");
        printf("%lld", ans[i]);
    }
}

你可能感兴趣的:(数据结构,无旋Treap)